require 'trick_or_treat/version'
require 'nokogiri'
require 'open-uri'
require 'tempfile'
require 'yaml'

module TrickOrTreat
  class Error < StandardError; end

  extend self

  attr_accessor :uri, :treat_file

  @uri='https://sergioro.mx'
  @treat_file='quotes.yml'

  def ask(args=[])
    printf "\e[1;38;05;202mTrick or Treat? "
    no_candy if Gem.win_platform?
    return trick if args.delete('trick')
    return treat if args.delete('treat')
    no_candy
  end

  def tempfile(headers={})
    stream = open([uri,treat_file].join('/'), "rb", headers)
    return stream if stream.respond_to?(:path)

    Tempfile.new.tap do |file|
      file.binmode
      IO.copy_stream(stream, file)
      stream.close
      file.rewind
    end
  end

  def get_links
    nodes=Nokogiri::HTML(open(uri)).css('a')
    nodes.map{|n| n['href'] if  n.attributes['class'].value.match /trick/i}.compact
  end

  def trick
    puts "\e[1;38;05;165mTrick\e[0m"
    links=get_links
    link=links.sample
    f=open([uri,link].join('/'))
    html=Nokogiri::HTML(f)
    puts title=html.css('h1').text.gsub(/  +|\n/, '')
    content=html.css('.post-content')
    IO.popen("less", "w") do |f|
       f.puts "\e[1m#{title}\e[0m\n#{content.text}"
    end
  end

  def treat
    printf "\e[1;38;05;165mTreat\e[0m\n"
    headers={}
    headers={'user-agent' => 'treat'}
    treats=YAML.load_file(tempfile(headers))
    treats[treats.keys.sample].values.sample
  rescue OpenURI::HTTPError => e
    response=e.io
    response.string
  end

  def no_candy
    return "\e[1;38;05;165mNo candy for you\e[0m"
  end
end
